/*
 * kintone-mfinvoice-item.js
 * Copyright (c) 2021 StrategIT
 *
 * Licensed under the MIT License
 */
(function() {
  'use strict';

  var validateErrorClear = function(event) {
    var record = event.record;
    event.error = '';
    record.detail.error = '';
    record.quantity.error = '';
    record.unit_price.error = '';
  };

  var validateRecord = function(event) {
    var record = event.record;
    var totalQuantityMessage = '単価×数量が -10,000,000,000 以上 10,000,000,000 以下になるよう入力してください。';
    var totalQuantity = 0;
    if (record.detail.value && record.detail.value.length > 200) {
      record.detail.error = '201文字より短くなければなりません。';
    }
    if (record.quantity.value && record.unit_price.value) {
      totalQuantity = record.quantity.value * record.unit_price.value;
      if (record.unit.value === '%') {
        totalQuantityMessage = '単位が「%」になっていますが、' + totalQuantityMessage;
      }
      if (totalQuantity < -10000000000 || totalQuantity > 10000000000) {
        record.quantity.error = totalQuantityMessage;
        record.unit_price.error = totalQuantityMessage;
      }
    }
    if (record.detail.error || record.quantity.error || record.unit_price.error) {
      event.error = '入力内容にエラーがあるため保存できません。';
    }
  };

  var concatenateStrings = function(record) {
    var name = record.name.value ? record.name.value : '';
    var itemCode = record.item_code.value ? record.item_code.value : '';
    record.name_code.value = name + ' ' + itemCode;
  };

  kintone.events.on([
    'app.record.create.submit',
    'app.record.edit.submit',
    'app.record.index.edit.submit'
  ], function(event) {
    var record = event.record;
    validateErrorClear(event);
    concatenateStrings(record);
    validateRecord(event);
    return event;
  });
})();